///webview/src/main/assets/js/hook-android.js
if (navigator.userAgent.indexOf('Android') > -1 || navigator.userAgent.indexOf('Adr') > -1) {
    console.log("Android Js Bridge Version:0.1.11");
    (function () {
        if (window._androidBridge) {
            return;
        }

        function obj2str(o) {
            var r = [];
            dLog('obj2str:typeof' + typeof o);
            if (typeof o === 'string') {
                return '"' + o.replace(/([\'\"\\])/g, '\\$1').replace(/(\n)/g, '\\n').replace(/(\r)/g, '\\r').replace(/(\t)/g, '\\t') + '"';
            }
            if (typeof o === 'undefined') {
                return 'undefined';
            }
            if (typeof o === 'object') {
                if (o === null) {
                    return 'null';
                } else if (!o.sort) {
                    for (var i in o) {
                        r.push('"' + i + '"' + ':' + obj2str(o[i]));
                    }
                    r = '{' + r.join() + '}';
                } else {
                    for (var i = 0; i < o.length; i++) {
                        r.push(obj2str(o[i]));
                    }
                    r = '[' + r.join() + ']';
                }
                dLog('obj2str:result | ' + r);
                return r;
            }
            dLog('obj2str:result | ' + o.toString());
            return o.toString();
        }

        var messagingIframe;
        var requestMap = {};

        function sendMessage(isAsync, message, callback) {
            dLog('sendMessage isAsync��' + isAsync + ',message:' + message + ',callback:' + callback);
            var key = genJsId();
            if (isAsync) {
                requestMap[key] = {
                    message: message,
                    callback: callback,
                };
                var data = {};
                data[key] = message;

                var value = obj2str(data).replace(":undefined",":null");
                prompt(value, value);
            } else {
                var value = 'jscb_sync' + ':' + obj2str(message).replace(":undefined",":null");
                var response = prompt(value, value);
                if(response.indexOf("DM_BRIDGE_ERROR") !== -1){
                    console.error(response);
                }
                if(response.startsWith("DMALL_TYPE[STRING]")){
                    response = response.replace("DMALL_TYPE[STRING]","");
                }else{
                    try{
                        response = JSON.parse(response);
                    }catch(e){

                    }
                }

                dLog(response);
                if (callback !== undefined) {
                    callback(response);
                }
                return response;
            }
        }
        window._sendMessage = sendMessage;
        var uniqueId = 1;

        function onJsCallback(message) {
            if(message&&message.indexOf("base64")>0){
                dLog('base64:may be too big, ignore print...');
            }else {
                dLog('onJsCallback:' + message);
            }
            dLog('requestMap:' + JSON.stringify(requestMap));
            var data = JSON.parse(message);
            for (var key in data) {
                dLog('key:' + key);
                var value = requestMap[key];
                dLog('value:' + value);
                dLog('valueCallbackInfo:' + value.callback);
                if (value.callback !== undefined) {
                    var pValue = data[key];
                    var typeOfData = typeof pValue;
                    var tryTime = 0;
                    while (typeOfData === 'string' && tryTime < 3) {
                        pValue = JSON.parse(pValue);
                        typeOfData = typeof pValue;
                        dLog('dataType:' + typeOfData + " tryTime:" + tryTime);
                        if (tryTime >= 2 && typeOfData === 'string') {
                            pValue = {data: pValue};
                        }
                        tryTime++
                    }
                    value.callback(pValue);
                } else {
                    dLog('data[key] errorInfo:' + data[key]);
                    if (data[key].indexOf("{\\\"TAG\\\":\\\"DM_BRIDGE_ERROR\\\",") > -1) {
                        console.error(data[key]);
                    }
                }
                delete requestMap[key];
                return;
            }
        }

        function genJsId() {
            return 'jscb_async_' + (uniqueId++) + '_' + new Date().getTime();
        }

        function onJavaRequest(message) {
            dLog('onJavaRequest:' + message);
            var data = JSON.parse(message);
            for (var key in data) {
                var result = eval(data[key]);
                dLog('result:' + result);
                data[key] = result;
                var value = JSON.stringify(data);
                prompt(value, value);
            }
        }


        window._androidBridge = {
            sendMessage: sendMessage,
            onJsCallback: onJsCallback,
            onJavaRequest: onJavaRequest,
        };


        function _createQueueReadyIframe(doc) {
            messagingIframe = doc.createElement('iframe');
            messagingIframe.style.display = 'none';
            doc.documentElement.appendChild(messagingIframe);
        }

        var doc = document;
        _createQueueReadyIframe(doc);
        var readyEvent = doc.createEvent('Events');
        readyEvent.initEvent('_androidBridge');
        readyEvent.bridge = _androidBridge;
        doc.dispatchEvent(readyEvent);
    })();
}
///webview/src/main/assets/js/hook-galleon-base.js
if (navigator.userAgent.indexOf('Android') > -1 || navigator.userAgent.indexOf('Adr') > -1) {
    window.dLog = function (msg) {
        if(window.androidDebug)
            console.log('Hook-Galleon:' + msg);
    };
    _galleon = window._galleon = window._galleonJs = {
        bridge: function (isAsync, className, method, data, callback) {
            dLog('bridge:' + JSON.stringify(data));

            function Result(className, method, data) {
                this.className = className;
                this.method = method;
                this.data = data;
            };
            var result = new Result(className, method, data);
            return window._sendMessage(isAsync, result, callback);
        },
    };
}
///webview/src/main/assets/js/api-android.js
if ((window.navigator.userAgent.indexOf('Android') > -1 || window.navigator.userAgent.indexOf('Adr') > -1)) {      
	window._dm = _dm = {
		_sendMessage: function _sendMessage(message, callback) {			
			var dotPos = message.method.lastIndexOf('.');
			window._galleonJs.bridge(true
				, message.method.substring(0, dotPos)
				, message.method.substring(dotPos === 0 ? 0 : dotPos + 1, message.method.length)
				, message.data
				, callback);
		},
		_sendMessageSync: function _sendMessageSync(message) {			
			var dotPos = message.method.lastIndexOf('.');
			return window._galleonJs.bridge(false
				, message.method.substring(0, dotPos)
				, message.method.substring(dotPos === 0 ? 0 : dotPos + 1, message.method.length)
				, message.data);
		},
		
		chooseFile: function chooseFile(message) {	
			var callback = message.callback;
			delete message.callback;		
			_dm._sendMessage({method:"chooseFile",data:message},callback);
		},
		chooseImage: function chooseImage(message) {
			var callback = message.callback;
			delete message.callback;		
			_dm._sendMessage({method:"chooseImage",data:message},callback);
		},
		chooseVideo: function chooseVideo(message) {
			var callback = message.callback;
			delete message.callback;			
			_dm._sendMessage({method:"chooseVideo",data:message},callback);
		},

		forward: function forward(message) {	
			var callback = message.callback;
			delete message.callback;	
			_dm._sendMessage({method:"forward",data:message},callback);
		},
		backward: function backward(message) {	
			var callback = message.callback;
			delete message.callback;	
			_dm._sendMessage({method:"backward",data:message},callback);
		},

		get: function get(message) {	
			var callback = message.callback;
			delete message.callback;	
			_dm._sendMessage({method:"get",data:message},callback);
		},
		set: function set(message) {	
			var callback = message.callback;
			delete message.callback;		
			_dm._sendMessage({method:"set",data:message},callback);
		},
		remove: function remove(message) {	
			var callback = message.callback;
			delete message.callback;	
			_dm._sendMessage({method:"remove",data:message},callback);
		},
		getSync: function getSync(message) {				
			delete message.callback;
			return	_vervifyCallback(_dm._sendMessageSync({method:"getSync",data:message}),String);
		},
		setSync: function setSync(message) {				
			delete message.callback;
			return	_vervifyCallback(_dm._sendMessageSync({method:"setSync",data:message}),String);
		},
		removeSync: function removeSync(message) {				
			delete message.callback;
			return	_vervifyCallback(_dm._sendMessageSync({method:"removeSync",data:message}),String);
		},

		request: function request(message) {	
			var callback = message.callback;
			delete message.callback;	
			_dm._sendMessage({method:"request",data:message},callback);
		},
		uploadFile: function uploadFile(message) {	
			var callback = message.callback;
			delete message.callback;	
			_dm._sendMessage({method:"uploadFile",data:message},callback);
		},
		
		getLocation: function getLocation(message) {	
			var callback = message.callback;
			delete message.callback;	
			_dm._sendMessage({method:"getLocation",data:message},callback);
		},
		getEnvSync: function getEnvSync() {
        	return	_vervifyCallback(_dm._sendMessageSync({method:"getEnvSync",data:{}}),String);
        },
		getHnRootPathSync: function getHnRootPathSync() {
        	return	_vervifyCallback(_dm._sendMessageSync({method:"getHnRootPathSync",data:{}}),String);
        },
        previewFile: function previewFile(message) {
        			var callback = message.callback;
        			delete message.callback;
        			_dm._sendMessage({method:"previewFile",data:message},callback);
        		},
        anchor:function anchor(){},

        setPageConfig: function setPageConfig(message){
        	var callback = message.callback;
            delete message.callback;
            _dm._sendMessage({method:"setPageConfig",data:message},callback);
        },
        getPageConfig: function getPageConfig(message){
        	var callback = message.callback;
            delete message.callback;
            return	_dm._sendMessage({method:"getPageConfig",data:message},callback);
        },
        getDeviceInfoSync: function getDeviceInfoSync(){
			return _vervifyCallback(_dm._sendMessageSync({method:"getDeviceInfoSync",data:{}}),Object);			
        },
        updateApp: function updateApp(message){
            return	_dm._sendMessage({method:"updateApp",data:message});
        }
	};
	function _vervifyCallback(result,type){		
		if(type === String){  
			if(typeof result==='string'){
				return result;
			}else{
				result = JSON.stringify(result);
				return result;
			}
			
		  }else{
			if(typeof result==='string'){
				try{
					result = JSON.parse(result);
				}catch(e){

				}
				return result;
			}else{
				return result;
			}
		  }
	}
}